// Copyright Take Vos 2019.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt)

#pragma once

#include "../color/sfloat_rg32.hpp"
#include <vulkan/vulkan.hpp>

namespace tt::pipeline_flat {

struct push_constants {
    sfloat_rg32 windowExtent = f32x4{ 0.0, 0.0 };
    sfloat_rg32 viewportScale = f32x4{ 0.0, 0.0 };

    static std::vector<vk::PushConstantRange> pushConstantRanges()
    {
        return {
            { vk::ShaderStageFlagBits::eVertex | vk::ShaderStageFlagBits::eFragment, 0, sizeof(push_constants) }
        };
    }
};

}
